diff -uNrd -x CVS ircd-comstud-1.12-REL/lib/send.c ircd-devel/lib/send.c
--- ircd-comstud-1.12-REL/lib/send.c	Wed Jul  5 13:48:03 2000
+++ ircd-devel/lib/send.c	Sun Dec  3 12:17:45 2000
@@ -55,12 +55,13 @@
 		cptr->c_send_bytes %= 1024;
 	}
 
+// humble
 	if (
 		IsServer(cptr) &&
 		!cptr->c_queue_out.queue_size &&
 		!(cptr->c_flags & CLIENT_FLAGS_DOINGCONNECT))
 	{
-		ret = write(cptr->c_connptr->fdlistinfo.fd, addptr, len);
+		ret = write(cptr->c_connptr->fd, addptr, len);
 		if (ret > 0)
 		{
 			if (IsClient(cptr))
@@ -79,64 +80,9 @@
 		cptr->c_flags |= CLIENT_FLAGS_DEAD;
 		return -1;
 	}
-#if 1
-	if (cptr->c_connptr->fdlistinfo.fdlist != Fdlist_main)
-	{
-		int mfd;
 
-		ret = fdlist_del_fd(cptr->c_connptr->fdlistinfo.fdlist,
-						cptr->c_connptr->fdlistinfo.fdlist_pos, &mfd);
-		if (mfd >= 0)
-		{
-			if (GET_FDS(mfd))
-				GET_FDS(mfd)->fdlistinfo.fdlist_pos =
-						cptr->c_connptr->fdlistinfo.fdlist_pos;
-		}
-		ret = ircd_open_fd(cptr->c_connptr->fdlistinfo.fd,
-					FDLIST_FLAGS_READ|FDLIST_FLAGS_WRITE, cptr->c_connptr, Fdlist_main);
-	}
-	else
-#endif
-		ret = fdlist_add_event(cptr->c_connptr->fdlistinfo.fdlist,
-				cptr->c_connptr->fdlistinfo.fdlist_pos, FDLIST_FLAGS_WRITE);
-	if ((cptr->c_queue_out.queue_size >= cptr->c_lastqsize + 4096) &&
-			!(cptr->c_flags & CLIENT_FLAGS_DOINGCONNECT))
-	{
-		char	*buf;
-		int		len;
+	ret = fdlist_add_event(cptr->c_connptr, FDLIST_FLAGS_WRITE);
 
-		if (cptr->c_writetries++ == 5)
-			cptr->c_writetries = 1;
-		if (cptr->c_writetries == 1)
-		{
-			ret = queue_data_get(&(cptr->c_queue_out), &buf, &len);
-			if (ret >= 0)
-			{
-				cptr->c_lastqsize = cptr->c_queue_out.queue_size;
-				ret = write(cptr->c_connptr->fdlistinfo.fd, buf, len);
-				if (ret > 0)
-				{
-					if (IsClient(cptr))
-						Globalinfo->bw_c_outgoing_bytes += ret;
-					else if (IsServer(cptr))
-						Globalinfo->bw_s_outgoing_bytes += ret;
-					cptr->c_writetries = 0;
-					queue_data_del(&(cptr->c_queue_out), ret);
-				}
-				else if (ret < 0)
-				{
-					if ((errno != EAGAIN) && (errno != EINTR) &&
-										(errno != EWOULDBLOCK))
-					{
-						cptr->c_flags |= CLIENT_FLAGS_DEAD;
-						return -1;
-					}
-					if (++cptr->c_writetries == 5)
-						cptr->c_writetries = 0;
-				}
-			}
-		}
-	}
 	return ret >= 0 ? len : ret;
 }
 
@@ -529,8 +475,8 @@
 	Sentalong_marker++;
 	if (IsLocal(pptr) && pptr->c_connptr)
 	{
-		assert(pptr->c_connptr->fdlistinfo.fd < Sentalong_size);
-		Sentalong[pptr->c_connptr->fdlistinfo.fd] = Sentalong_marker;
+		assert(pptr->c_connptr->fd < Sentalong_size);
+		Sentalong[pptr->c_connptr->fd] = Sentalong_marker;
 	}
 
 	*clientbuf = ':';
@@ -572,9 +518,9 @@
 		for(users=chlptr->chptr->members;users;users=users->next)
 		{
 			cptr = users->cptr;
-			if (!IsLocal(cptr) || !cptr->c_connptr || (Sentalong[cptr->c_connptr->fdlistinfo.fd] == Sentalong_marker))
+			if (!IsLocal(cptr) || !cptr->c_connptr || (Sentalong[cptr->c_connptr->fd] == Sentalong_marker))
 				continue;
-			Sentalong[cptr->c_connptr->fdlistinfo.fd] = Sentalong_marker;
+			Sentalong[cptr->c_connptr->fd] = Sentalong_marker;
 			_send_message_to_client(cptr, clientbuf, len+2);
 		}
 	}
@@ -666,11 +612,11 @@
 			if (!(flags & CHANNEL_SEND_CLIENTS))
 				continue;
 		}
-		assert(cptr->c_connptr->fdlistinfo.fd < Sentalong_size);
+		assert(cptr->c_connptr->fd < Sentalong_size);
 		if (!cptr->c_connptr ||
-			(Sentalong[cptr->c_connptr->fdlistinfo.fd] == Sentalong_marker))
+			(Sentalong[cptr->c_connptr->fd] == Sentalong_marker))
 				continue;
-		Sentalong[cptr->c_connptr->fdlistinfo.fd] = Sentalong_marker;
+		Sentalong[cptr->c_connptr->fd] = Sentalong_marker;
 		if (IsServer(cptr))
 			_send_message_to_client(cptr, serverbuf, slen+2);
 		else
@@ -750,11 +696,11 @@
 			if (!(flags & CHANNEL_SEND_CLIENTS))
 				continue;
 		}
-		assert(cptr->c_connptr->fdlistinfo.fd < Sentalong_size);
+		assert(cptr->c_connptr->fd < Sentalong_size);
 		if (!cptr->c_connptr ||
-			(Sentalong[cptr->c_connptr->fdlistinfo.fd] == Sentalong_marker))
+			(Sentalong[cptr->c_connptr->fd] == Sentalong_marker))
 				continue;
-		Sentalong[cptr->c_connptr->fdlistinfo.fd] = Sentalong_marker;
+		Sentalong[cptr->c_connptr->fd] = Sentalong_marker;
 		if (IsServer(cptr))
 			_send_message_to_client(cptr, serverbuf, slen+2);
 		else
